//*****************************************************************************
//
// @brief   Font renderer for fonts generated by LCD Image Converter utility
//          (see https://github.com/riuson/lcd-image-converter).
// @author  Vadim Mezhlumov
//
//*****************************************************************************

// Note:
// -----
// Currently supported only format with following settings in the application:
// - preset name: Grayscale 4
// - data block size: 8 bit(s), uint8_t
// - RLE compression enabled: yes
// - conversion type: Grayscale, not_used not_used
// - split to rows: no
// - bits per pixel: 4

#include "ui/fonts/lcd_image_converter.h"


/**
 * @brief  Get symbol descriptor
 * @param  c: Symbol code
 * @param  pDesc: Pointer to font descriptor
 * @return Pointer to symbol descriptor or null on error
 */
static const TLicCharInfo* getCharInfo (int c, const TLicFontDesc* pDesc)
{
    if (!pDesc) return nullptr;

    // Symbols in font descriptor are sorted by their code in ascending order.
    // To increase searching speed jumps by halfs of ranges is used.
    const TLicCharInfo* pResult = nullptr;
    uint range = pDesc->length;

    for (int i = 0; range && i >= 0 && i < pDesc->length; )
    {
        const TLicCharDesc* pCharInfo = &pDesc->chars[i];

        if (pCharInfo->code == c)
        {
            pResult = pCharInfo->image;
            break;
        }

        if (range == 1) break;
        range = (range + 1) / 2;

        if (c < pCharInfo->code)    i -= range;
        else                        i += range;
    }

    return pResult;
}


/**
 * @brief  Constructor
 * @param  pDesc: Pointer to font descriptor
 */
CFontLcdImgConv::CFontLcdImgConv (const TLicFontDesc* pDesc) :
    IFont(),
    m_pDesc(pDesc)
{
}


/**
 * @brief  Destructor
 * @param  None
 */
CFontLcdImgConv::~CFontLcdImgConv ()
{
}


/**
 * @brief  Get font height
 * @return Font height (pixels)
 */
uint CFontLcdImgConv::GetHeight (void)
{
    if (!m_pDesc || !m_pDesc->chars || !m_pDesc->length) return 0;

    return m_pDesc->chars[0].image->height;
}


/**
 * @brief  Get symbol width
 * @param  c: Symbol code
 * @return Symbol width (pixels)
 */
uint CFontLcdImgConv::GetWidth (int c)
{
    if (!m_pDesc) return 0;

    const TLicCharInfo* pInfo = getCharInfo(c, m_pDesc);
    return (pInfo) ? pInfo->width : 0;
}


/**
 * @brief  Render symbol
 * @param  renderer: Renderer
 * @param  c: Symbol code
 * @param  color: Text color
 * @return 0 or negative error code
 */
int CFontLcdImgConv::Render (CRenderer& renderer, int c, TColor color)
{
    const TLicCharInfo* pInfo = getCharInfo(c, m_pDesc);
    if (!pInfo) return -1;

    uint pixelsCount = pInfo->width * pInfo->height;
    const uint pixelsInbyte = 2;
    const uint bitsInPixel = 8 / pixelsInbyte;
    const uint8 mask = (uint8) ~(0xff << bitsInPixel);
    const uint8* ptr = pInfo->data;
    int counter = 0;
    int tmpl = -1;
    uint16 x = 0;
    uint16 y = 0;

    while (pixelsCount)
    {
        if (!counter)
        {
            counter = (int8) *ptr++;
            if (!counter) break;

            if (counter < 0)
            {
                tmpl = -1;
                counter = -counter;
            }
            else
            {
                tmpl = *ptr++;
            }
            continue;
        }

        uint8 byte = (tmpl < 0) ? *ptr++ : tmpl;
        --counter;

        for (uint i = 0; pixelsCount && i < pixelsInbyte; ++i, ++x, --pixelsCount)
        {
            if (x >= pInfo->width)
            {
                x = 0;
                ++y;
            }

            uint maskOffset = (pixelsInbyte - i - 1) * bitsInPixel;
            uint8_t factor = (byte >> maskOffset) & mask;
            if (factor == 0) continue;

            TColor pxColor = color;
            if (factor != mask) pxColor.a = (color.a >> bitsInPixel) * factor;

            renderer.PutPixel(x, y, pxColor);
        }
    }

    return (pixelsCount) ? -10 : 0;
}
